Index: /trunk/library/ckeditor/config.js
===================================================================
--- /trunk/library/ckeditor/config.js	(revision 5135)
+++ /trunk/library/ckeditor/config.js	(revision 5417)
@@ -25,15 +25,16 @@
 		   config.disableNativeSpellChecker = false;
            config.removePlugins = 'elementspath,scayt,menubutton';
+		   config.resize_enabled = false;
            config.toolbarCanCollapse = false;  
            config.toolbar_mail =
            [ 
-                ['Font','FontSize','Bold','Italic','Underline','Strike','TextColor','BGColor','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','NumberedList','BulletedList','-','Undo','Redo','Link','Unlink','Anchor','-','Find','Replace','Outdent','Indent'], '/', 
-                ['Cut','Copy','Paste','PasteText','PasteFromWord','-','Table','HorizontalRule','SpecialChar','expAddImage','expSignature','SpellCheck','Maximize'] 
+                ['SpellCheck','-','Cut','Copy','Paste','PasteText','PasteFromWord','-','Undo','Redo','-','Link','Unlink','Anchor','-','Find','Replace','-','Outdent','Indent','-','Table','HorizontalRule','SpecialChar','expAddImage','-','Maximize'], '/', 
+                ['Font','FontSize','Bold','Italic','Underline','Strike','TextColor','BGColor','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','NumberedList','BulletedList','-','expSignature'] 
            ];
 
            config.toolbar_signature =
            [ 
-               ['Font','FontSize','Bold','Italic','Underline','Strike','TextColor','BGColor','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','NumberedList','BulletedList'], '/', 
-               ['Undo','Redo','Link','Unlink','Anchor','-','Outdent','Indent','-','Cut','Copy','Paste','PasteText','PasteFromWord','-','Table','HorizontalRule','SpecialChar','SpellCheck','Maximize'] 
+               ['SpellCheck','-','Cut','Copy','Paste','PasteText','PasteFromWord','-','Undo','Redo','-','Link','Unlink','Anchor','-','Outdent','Indent','-','Table','HorizontalRule','SpecialChar','-','Maximize'],'/',
+               ['Font','FontSize','Bold','Italic','Underline','Strike','TextColor','BGColor','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','NumberedList','BulletedList'] 
            ];
 };
Index: /trunk/prototype/plugins/jquery-elastic/jquery.elastic.source.js
===================================================================
--- /trunk/prototype/plugins/jquery-elastic/jquery.elastic.source.js	(revision 5417)
+++ /trunk/prototype/plugins/jquery-elastic/jquery.elastic.source.js	(revision 5417)
@@ -0,0 +1,162 @@
+/**
+*	@name							Elastic
+*	@descripton						Elastic is jQuery plugin that grow and shrink your textareas automatically
+*	@version						1.6.11
+*	@requires						jQuery 1.2.6+
+*
+*	@author							Jan Jarfalk
+*	@author-email					jan.jarfalk@unwrongest.com
+*	@author-website					http://www.unwrongest.com
+*
+*	@licence						MIT License - http://www.opensource.org/licenses/mit-license.php
+*/
+
+(function($){ 
+	jQuery.fn.extend({  
+		elastic: function() {
+		
+			//	We will create a div clone of the textarea
+			//	by copying these attributes from the textarea to the div.
+			var mimics = [
+				'paddingTop',
+				'paddingRight',
+				'paddingBottom',
+				'paddingLeft',
+				'fontSize',
+				'lineHeight',
+				'fontFamily',
+				'width',
+				'fontWeight',
+				'border-top-width',
+				'border-right-width',
+				'border-bottom-width',
+				'border-left-width',
+				'borderTopStyle',
+				'borderTopColor',
+				'borderRightStyle',
+				'borderRightColor',
+				'borderBottomStyle',
+				'borderBottomColor',
+				'borderLeftStyle',
+				'borderLeftColor'
+				];
+			
+			return this.each( function() {
+
+				// Elastic only works on textareas
+				if ( this.type !== 'textarea' ) {
+					return false;
+				}
+					
+			var $textarea	= jQuery(this),
+				$twin		= jQuery('<div />').css({
+					'position'		: 'absolute',
+					'display'		: 'none',
+					'word-wrap'		: 'break-word',
+					'white-space'	:'pre-wrap'
+				}),
+				lineHeight	= parseInt($textarea.css('line-height'),10) || parseInt($textarea.css('font-size'),'10'),
+				minheight	= parseInt($textarea.css('height'),10) || lineHeight*3,
+				maxheight	= parseInt($textarea.css('max-height'),10) || Number.MAX_VALUE,
+				goalheight	= 0;
+				
+				// Opera returns max-height of -1 if not set
+				if (maxheight < 0) { maxheight = Number.MAX_VALUE; }
+					
+				// Append the twin to the DOM
+				// We are going to meassure the height of this, not the textarea.
+				$twin.appendTo($textarea.parent());
+				
+				// Copy the essential styles (mimics) from the textarea to the twin
+				var i = mimics.length;
+				while(i--){
+					$twin.css(mimics[i].toString(),$textarea.css(mimics[i].toString()));
+				}
+				
+				// Updates the width of the twin. (solution for textareas with widths in percent)
+				function setTwinWidth(){
+					var curatedWidth = Math.floor(parseInt($textarea.width(),10));
+					if($twin.width() !== curatedWidth){
+						$twin.css({'width': curatedWidth + 'px'});
+						
+						// Update height of textarea
+						update(true);
+					}
+				}
+				
+				// Sets a given height and overflow state on the textarea
+				function setHeightAndOverflow(height, overflow){
+				
+					var curratedHeight = Math.floor(parseInt(height,10));
+					if($textarea.height() !== curratedHeight){
+						$textarea.css({'height': curratedHeight + 'px','overflow':overflow});
+					}
+				}
+				
+				// This function will update the height of the textarea if necessary 
+				function update(forced) {
+					
+					// Get curated content from the textarea.
+					var textareaContent = $textarea.val().replace(/&/g,'&amp;').replace(/ {2}/g, '&nbsp;').replace(/<|>/g, '&gt;').replace(/\n/g, '<br />');
+					
+					// Compare curated content with curated twin.
+					var twinContent = $twin.html().replace(/<br>/ig,'<br />');
+					
+					if(forced || textareaContent+'&nbsp;' !== twinContent){
+					
+						// Add an extra white space so new rows are added when you are at the end of a row.
+						$twin.html(textareaContent+'&nbsp;');
+						
+						// Change textarea height if twin plus the height of one line differs more than 3 pixel from textarea height
+						if(Math.abs($twin.height() + lineHeight - $textarea.height()) > 3){
+							
+							var goalheight = $twin.height()+lineHeight;
+							if(goalheight >= maxheight) {
+								setHeightAndOverflow(maxheight,'auto');
+							} else if(goalheight <= minheight) {
+								setHeightAndOverflow(minheight,'hidden');
+							} else {
+								setHeightAndOverflow(goalheight,'hidden');
+							}
+							
+						}
+						
+					}
+					
+				}
+				
+				// Hide scrollbars
+				$textarea.css({'overflow':'hidden'});
+				
+				// Update textarea size on keyup, change, cut and paste
+				$textarea.bind('keyup change cut paste', function(){
+					update(); 
+				});
+				
+				// Update width of twin if browser or textarea is resized (solution for textareas with widths in percent)
+				$(window).bind('resize', setTwinWidth);
+				$textarea.bind('resize', setTwinWidth);
+				$textarea.bind('update', update);
+				
+				// Compact textarea on blur
+				$textarea.bind('blur',function(){
+					if($twin.height() < maxheight){
+						if($twin.height() > minheight) {
+							$textarea.height($twin.height());
+						} else {
+							$textarea.height(minheight);
+						}
+					}
+				});
+				
+				// And this line is to catch the browser paste event
+				$textarea.bind('input paste',function(e){ setTimeout( update, 250); });				
+				
+				// Run update once when elastic is initialized
+				update();
+				
+			});
+			
+        } 
+    }); 
+})(jQuery);
Index: /trunk/expressoMail1_2/index.php
===================================================================
--- /trunk/expressoMail1_2/index.php	(revision 5409)
+++ /trunk/expressoMail1_2/index.php	(revision 5417)
@@ -45,4 +45,5 @@
 					<script type='text/javascript' src='../prototype/plugins/alphanumeric/jquery.alphanumeric.js'></script>
 					<script type='text/javascript' src='../prototype/plugins/timepicker/localization/jquery-ui-timepicker-pt-BR.js'></script>
+					<script type='text/javascript' src='../prototype/plugins/jquery-elastic/jquery.elastic.source.js'></script>
                                         <script type='text/javascript' src='../prototype/modules/calendar/js/calendar.date.js'></script>
                                         <script type='text/javascript' src='../prototype/modules/calendar/js/helpers.js'></script>
Index: /trunk/expressoMail1_2/setup/phpgw_pt-br.lang
===================================================================
--- /trunk/expressoMail1_2/setup/phpgw_pt-br.lang	(revision 5372)
+++ /trunk/expressoMail1_2/setup/phpgw_pt-br.lang	(revision 5417)
@@ -464,4 +464,6 @@
 Sender's Information	expressoMail1_2	pt-br	Dados do Remetente
 Send	expressoMail1_2	pt-br	Enviar
+Send Mail	expressoMail1_2	pt-br	Enviar Email
+Save Mail	expressoMail1_2	pt-br	Salvar Email
 Send and not file	expressoMail1_2	pt-br	Enviar sem Arquivar
 Send from queue	expressoMail1_2	pt-br	Enviar fila
Index: /trunk/expressoMail1_2/js/common_functions.js
===================================================================
--- /trunk/expressoMail1_2/js/common_functions.js	(revision 5264)
+++ /trunk/expressoMail1_2/js/common_functions.js	(revision 5417)
@@ -547,5 +547,5 @@
 }
 
-function emQuickSearch(emailList, field, ID, Type){
+function emQuickSearch(emailList, field, ID, Type, force){
 	var quickSearchKeyBegin;
 	var quickSearchKeyEnd;
@@ -593,5 +593,8 @@
 		return true;
 	}
-
+	if(force){
+		cExecute ("$this.ldap_functions.quicksearchcontact&search_for="+''+"&field="+field+"&ID="+ID, handler_emQuickSearch);
+		return;
+	}
 	if ((field != 'null') && (ID != 'null'))
 	{
Index: /trunk/expressoMail1_2/js/main.js
===================================================================
--- /trunk/expressoMail1_2/js/main.js	(revision 5415)
+++ /trunk/expressoMail1_2/js/main.js	(revision 5417)
@@ -233,5 +233,6 @@
 			var save_link = Element("save_message_options_"+border_id);
 			save_link.onclick = function onclick(event) {openTab.toPreserve[border_id] = true;save_msg(border_id);} ;
-			save_link.className = 'message_options';
+			$("#save_message_options_"+border_id).button({ disabled: false });
+			$(".header-button").button();
 		};
 
@@ -247,5 +248,20 @@
 		else if ( to_obj.attachEvent )
 			to_obj.attachEvent('onkeypress', keypress_handler);
-        
+			
+		var cc_obj = document.getElementById('cc_'+border_id);
+		if ( cc_obj.addEventListener )
+				cc_obj.addEventListener('keypress', keypress_handler, false);
+		else if ( cc_obj.attachEvent )
+			cc_obj.attachEvent('onkeypress', keypress_handler);
+		
+		var cco_obj = document.getElementById('cco_'+border_id);
+		if ( cco_obj.addEventListener )
+				cco_obj.addEventListener('keypress', keypress_handler, false);
+		else if ( cco_obj.attachEvent )
+			cco_obj.attachEvent('onkeypress', keypress_handler);
+
+		//var important_obj = $("important_message_options_"+border_id).bind('click',keypress_handler);
+			//important_obj.addEventListener('click', keypress_handler, false);
+			
         var txtarea_obj = Element('body_'+border_id);
         if (txtarea_obj){
@@ -1397,13 +1413,13 @@
 			Element("subject_" + new_border_ID).value = "Re: " + data.subject;			
 
-	if (data.is_local_message){  
-		alert(get_lang("In the local file attachments, including images, will be disregarded. To forward / reply with the attachments, please first make the reopening of the message")+'.');  
-        var imagens = data.body.match(/<img[^>]*>/g);  
-        if(imagens != null)  
-			for (var x = 0; x < imagens.length; x++)  
-				data.body = data.body.replace(imagens[x],'');  
-	}else{
-		useOriginalAttachments(new_border_ID,border_ID);			
-	}      
+			if (data.is_local_message){  
+				alert(get_lang("In the local file attachments, including images, will be disregarded. To forward / reply with the attachments, please first make the reopening of the message")+'.');  
+				var imagens = data.body.match(/<img[^>]*>/g);  
+				if(imagens != null)  
+					for (var x = 0; x < imagens.length; x++)  
+						data.body = data.body.replace(imagens[x],'');  
+			}else{
+				useOriginalAttachments(new_border_ID,border_ID);			
+			}      
 
 			// Insert the signature automaticaly at message body if use_signature preference is set
@@ -1467,11 +1483,19 @@
 				data.cc = removeUserEmail(_array_cc);
 				data.cc = removeAlternative(data.cc,_array_to_alternative);
-	
-				Element("cc_" + new_border_ID).value = data.cc;
-				Element("a_cc_link_" + new_border_ID).style.display='none';
-				Element("tr_cc_" + new_border_ID).style.display='';
-				var space_link = Element('space_link_' + new_border_ID);
-				if (space_link)
-					space_link.style.display='none';
+					if (data.cc != get_lang("undisclosed-recipient"))
+						data.cc = data.cc.join(",");
+					else
+						data.cc = "";			
+				if(data.cc == ""){
+					//document.getElementById("cc_" + new_border_ID).value = data.cc;
+					document.getElementById("tr_cc_" + new_border_ID).style.display='none';
+				}else{
+					document.getElementById("cc_" + new_border_ID).value = data.cc;
+					document.getElementById("tr_cc_" + new_border_ID).style.display='';
+					//document.getElementById("a_cc_link" + new_border_ID).value = data.cc;
+					$("#a_cc_link_"+new_border_ID).toggleClass("expressomail-button-icon-ative");
+					$("#a_cc_link_"+new_border_ID).find("span").html("Remover CC");
+					$("#cc_"+new_border_ID).elastic().unbind('blur');
+				}
 			}
 			if (data.is_local_message){  
@@ -1518,10 +1542,15 @@
 					else
 						data.cc = "";			
-				document.getElementById("cc_" + new_border_ID).value = data.cc;
-				document.getElementById("a_cc_link_" + new_border_ID).style.display='none';
-				document.getElementById("tr_cc_" + new_border_ID).style.display='';
-				var space_link = document.getElementById('space_link_' + new_border_ID);
-				if ( space_link )
-				  space_link.style.display='none';
+				if(data.cc == ""){
+					//document.getElementById("cc_" + new_border_ID).value = data.cc;
+					document.getElementById("tr_cc_" + new_border_ID).style.display='none';
+				}else{
+					document.getElementById("cc_" + new_border_ID).value = data.cc;
+					document.getElementById("tr_cc_" + new_border_ID).style.display='';
+					//document.getElementById("a_cc_link" + new_border_ID).value = data.cc;
+					$("#a_cc_link_"+new_border_ID).toggleClass("expressomail-button-icon-ative");
+					$("#a_cc_link_"+new_border_ID).find("span").html("Remover CC");
+					$("#cc_"+new_border_ID).elastic().unbind('blur');
+				}
 			}
 			document.getElementById("subject_" + new_border_ID).value = "Re: " + data.subject;
@@ -1667,14 +1696,25 @@
 				data.cc = data.cc.replace(/&gt;/gi,">");
 				Element("cc_" + new_border_ID).value = data.cc;
-				Element("a_cc_link_" + new_border_ID).style.display = 'none';
-				if(Element("cco_" + new_border_ID) != null)
-					Element("space_link_" + new_border_ID).style.display = 'none';
+				Element("cc_" + new_border_ID).style.display = "";
 				Element("tr_cc_"+ new_border_ID).style.display = '';
+				Element("cc_" + new_border_ID).style.width = "100%";
+				$("#a_cc_link_"+new_border_ID).toggleClass("expressomail-button-icon-ative");
+				$("#a_cc_link_"+new_border_ID).find("span").html("Remover CC");
+				$("#cc_"+new_border_ID).elastic().unbind('blur');
+				//Element("a_cc_link_" + new_border_ID).style.display = 'none';
+				//if(Element("cco_" + new_border_ID) != null)
+				//	Element("space_link_" + new_border_ID).style.display = 'none';
 			}
 			if (data.cco){
 				if(Element("cco_" + new_border_ID) != null){
 				Element("cco_" + new_border_ID).value = data.cco;
-				Element("space_link_" + new_border_ID).style.display = 'none';
-				Element("a_cco_link_" + new_border_ID).style.display = 'none';
+				Element("cco_" + new_border_ID).style.display = '';
+				Element("cco_" + new_border_ID).style.width = "100%";
+				Element("tr_cco_"+ new_border_ID).style.display = '';
+				$("#a_cco_link_"+new_border_ID).toggleClass("expressomail-button-icon-ative");
+				$("#a_cco_link_"+new_border_ID).find("span").html("Remover CC");
+				$("#cco_"+new_border_ID).elastic().unbind('blur');
+				//Element("space_link_" + new_border_ID).style.display = 'none';
+				//Element("a_cco_link_" + new_border_ID).style.display = 'none';
 				Element("tr_cco_"+ new_border_ID).style.display = '';
 			}
@@ -1682,12 +1722,18 @@
 			Element("subject_" + new_border_ID).value = data.subject;
 			
-			if( Element("disposition_notification_" + border_ID) )
-				Element("return_receipt_" + new_border_ID).checked = true;
+			if( Element("disposition_notification_" + border_ID) ){
+				$("#return_receipt_"+new_border_ID).attr("checked", true);
+				$("[name=return_receipt_"+new_border_ID+"]").toggleClass("expressomail-button-icon-ative");
+				//Element("return_receipt_" + new_border_ID).checked = true;
+			}
 
 			var element_important_message = Element("important_message_" + new_border_ID);
 			if(element_important_message) {
 					
-				if(Element("disposition_important_" + border_ID))
-					element_important_message.checked = true;				
+				if(Element("disposition_important_" + border_ID)){
+					$("#important_message_"+new_border_ID).attr("checked", true);
+					$("[name=important_message_"+new_border_ID+"]").toggleClass("expressomail-button-icon-ative");
+					//element_important_message.checked = true;		
+				}
 			}
 
@@ -1730,5 +1776,4 @@
 	Element("border_id_" + new_border_ID).title = title;
 	set_border_caption("border_id_" + new_border_ID, title);
-
 	resizeWindow();
 	//save_msg(new_border_ID);
@@ -1908,5 +1953,6 @@
 		var save_link = Element("save_message_options_"+ID);
 		save_link.onclick = function onclick(event) {openTab.toPreserve[ID] = true;save_msg(ID);} ;
-		save_link.className = 'message_options';
+		$("#save_message_options_"+ID).button({ disabled: false });
+		//save_link.className = 'message_options';
 	}
 	if(!expresso_offline)
@@ -1989,5 +2035,5 @@
 		//entrava em execucao (a aba de edicao da mensagem continuava aberta e a mensagem exibida era a de que a mensagem foi
 		//salva na pasta Rascunhos e nao que tinha sido enviada, como deveria);
-		if (preferences.auto_save_draft == 1)
+	if (preferences.auto_save_draft == 1)
 	{
 		if (openTab.autosave_timer[ID])
@@ -2001,5 +2047,6 @@
         var onClick = save_link.onclick;
 	save_link.onclick = '';
-	save_link.className = 'message_options_inactive';
+	$("#save_message_options_"+ID).button({ disabled: true });
+	//save_link.className = 'message_options_inactive';
 
 	ID_tmp = ID;
@@ -2084,7 +2131,10 @@
 	
 	if ( Element("cco_"+ID) != null)
-		stringEmail += Element("cco_"+ID).value =='' ? "":", "+Element("cco_"+ID).value;
-	
-	stringEmail += Element("cc_"+ID).value =='' ? "":", "+Element("cc_"+ID).value;
+		if(Element("tr_cco_"+ID).style.display != "none")
+			stringEmail += Element("cco_"+ID).value =='' ? "":", "+Element("cco_"+ID).value;
+			
+	if(Element("tr_cc_"+ID).style.display != "none")
+		stringEmail += Element("cc_"+ID).value =='' ? "":", "+Element("cc_"+ID).value;
+		
 	if (expresso_offline) {
 		
@@ -2104,4 +2154,5 @@
 	}
 	else{
+		alert(form);
 		if(stringEmail != "")
 			cExecuteForm("$this.imap_functions.send_mail", form, handler_send_message, ID);
@@ -2348,6 +2399,6 @@
 			if(!withImage){
 				if(data.append === true){
-					save_link.className = 'message_options_inactive';
-					save_link.onclick = '';
+					$("#save_message_options_"+border_id).button();
+					$("#save_message_options_"+border_id).button({ disabled: true });
 					watch_changes_in_msg(border_id);	
 					write_msg(get_lang('Your message was save as draft in folder %1.', lang_folder(folder_name)));
